#include "Midi.h"
#include <vector>

void MidiIn::setCallback( MidiIn::MidiMessageInCallback callback, void *userData )
{
	userCallback = callback;
    userCallbackData = userData;

	RtMidiIn::setCallback( rtmidiCallback, (void*) this );
}

void MidiIn::rtmidiCallback( double timeStamp, std::vector<unsigned char> *messageBytes, void *callbackData )
{
	MidiIn *midiin = (MidiIn*) callbackData;

	MidiMessage* message = MidiMessage::parseMessage(*messageBytes);
	midiin->userCallback( timeStamp, *message, midiin->userCallbackData );
	delete message;
}

void MidiOut::sendMessage(MidiMessage& message)
{
	std::vector<unsigned char> bytes = message.getBytes();
	RtMidiOut::sendMessage(&bytes);
}
