#pragma once

#include <vector>
#include "RtMidi.h"
#include "MidiMessage.h"

class MidiIn : public RtMidiIn
{
public:
	typedef void (*MidiMessageInCallback)( double timeStamp, MidiMessage &message, void *userData );
	void setCallback( MidiMessageInCallback callback, void *userData = 0 );

protected:
	MidiMessageInCallback userCallback;
    void *userCallbackData;
	
private:
	static void rtmidiCallback( double timeStamp, std::vector<unsigned char> *message, void *midiin );
};

class MidiOut : public RtMidiOut
{
public:
	void sendMessage(MidiMessage& message);
};
